#REM
			Charge Controller _ Piglet 08M
			Ver 1		17th February 2008
	Amp Data compiler & feed to Charge Controller v3 for the 3 x Source Input

#ENDREM



	#picaxe 08M				;commands Programming Editor to use its 08M settings

rem                 w0			; tempoary values
SYMBOL  solA  	= b2			; Measured Solar Amps
SYMBOL  winA  	= b3			; Measured Wind Amps
SYMBOL  hydA  	= b4			; Measured Hydro Amps
SYMBOL  TgenA  	= b5			; Total Generated Amps



Main:
	DO
	readadc 1, w0				; read in Solar Amps ADC signal
	w0 = w0 max 127
	solA = 127 - w0 * 29 / 61		; calculate Solar Amps
	if solA > 50 then gosub Fix1		; check calc for underflow
	readadc 2, w0				; read in Wind Amps ADC signal
	w0 = w0 max 128
	winA = 128 - w0 * 29 / 61		; calculate Wind Amps
	if winA > 50 then gosub Fix2		; check calc for underflow	
	readadc 4, w0				; read in Hydro Amps ADC signal
	w0 = w0 max 128
	hydA = 128 - w0 * 29 / 61		; calculate Hydro Amps
	if hydA > 50 then gosub Fix3		; check calc for underflow
	TgenA = solA + winA + hydA		; calculate Total Generated Amps
	serout 0,N1200,("TW",solA,winA,hydA,TgenA)	; send data to mother pig
	;sertxd (#solA,"Sol Amps__",#winA,"Wind Amps__",#hydA,"Hydro Amps__",#TgenA,"TotalGen Amps"cr,lf)	; **for setup only**
	;pause 3000					; ** for setup only **
	LOOP

Fix1:
	solA = 0				; fix underflow error
	return
Fix2:	
	winA = 0				; fix underflow error
	return
Fix3:
	hydA = 0				; fix underflow error
	return	


END













